package core.api.models.timemanager.taskgroup;

import com.fasterxml.jackson.annotation.JsonProperty;
import core.entities.timemanager.Taskgroup;

import java.util.ArrayList;
import java.util.List;

public class TaskgroupPathInfo {

    @JsonProperty
    private String taskgroupPath;

    @JsonProperty
    private List<TaskgroupEntityInfo> directChildren;
    public TaskgroupPathInfo(Taskgroup taskgroup) {
        List<Taskgroup> taskgroupPath = Taskgroup.getAncestorList(taskgroup);
        StringBuilder stringBuilder = new StringBuilder();
        for(Taskgroup taskgroupPathEntity : taskgroupPath) {
            stringBuilder.append(taskgroupPathEntity.getTaskgroupName());
            stringBuilder.append("/");
        }
        this.taskgroupPath = stringBuilder.substring(0, stringBuilder.length()-1);
        directChildren = taskgroup.getChildren().stream().map(TaskgroupEntityInfo::new).toList();
    }
}
